//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com/en/users/abiotamalo"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#include <Canvas\Canvas.mqh>
#include <Canvas\Charts\HistogramChart.mqh>
CHistogramChart chart;

int Counter = 0;
CCanvas canvas2222;
CCanvas canvas11111;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+`
int OnInit(void)
  {
   ObjectsDeleteAll(0,"Test");
//--- create canvas
   int x=0;
   int y=0;
   ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,114),iHigh(Symbol(),PERIOD_CURRENT,114),x,y);
   int x1=0;
   int y1=0;
   ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,97),iLow(Symbol(),PERIOD_CURRENT,97),x1,y1);
   double priceWidth=x1-x;
   double priceHeight=y1-y;
   uchar alpha=80;
   bool objCreated=false;
   double barHeight=priceHeight/200;
   if(true)
     {
      bool objCreated=canvas11111.CreateBitmap("Test_11111",iTime(Symbol(),PERIOD_CURRENT,114),iHigh(Symbol(),PERIOD_CURRENT,114),x1-x,y1-y,COLOR_FORMAT_ARGB_NORMALIZE);
      canvas11111.Erase(ColorToARGB(clrNONE, 0));
      canvas11111.FillRectangle(0,0,200,200,ColorToARGB(clrBlue,alpha));
      //canvas11111.TransparentLevelSet(alpha);
      canvas11111.Update();
     }
   ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,50),iHigh(Symbol(),PERIOD_CURRENT,114),x,y);
   x1=0;
   y1=0;
   ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,5),iLow(Symbol(),PERIOD_CURRENT,97),x1,y1);
   priceWidth=x1-x;
   priceHeight=y1-y;
   alpha=80;
   objCreated=false;
   if(true)
     {
      objCreated=canvas2222.CreateBitmap("Test_2222",iTime(Symbol(),PERIOD_CURRENT,50),iHigh(Symbol(),PERIOD_CURRENT,50),x1-x,y1-y,COLOR_FORMAT_ARGB_NORMALIZE);
      canvas2222.Erase(ColorToARGB(clrNONE, 0));
      //      canvas2222.Update();
      barHeight=priceHeight/200;
      canvas2222.FillRectangle(0,0,200,200,ColorToARGB(clrRed,alpha));
      //canvas2222.TransparentLevelSet(alpha);
      canvas2222.Update();
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return rates_total;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_CHART_CHANGE)
     {
      ++Counter;
      int x=0;
      int y=0;
      ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,114),iHigh(Symbol(),PERIOD_CURRENT,114),x,y);
      int x1=0;
      int y1=0;
      ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,97),iLow(Symbol(),PERIOD_CURRENT,97),x1,y1);
      double priceWidth=x1-x;
      double priceHeight=y1-y;
      canvas11111.FillRectangle(0,0,priceWidth,priceHeight,ColorToARGB(clrBlue,80));
      canvas11111.Update();
      //ObjectSetInteger(0,"Test_11111",OBJPROP_XSIZE,priceWidth);
      //ObjectSetInteger(0,"Test_11111",OBJPROP_YSIZE,priceHeight);
      x=0;
      y=0;
      ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,50),iHigh(Symbol(),PERIOD_CURRENT,114),x,y);
      x1=0;
      y1=0;
      ChartTimePriceToXY(0,0,iTime(Symbol(),PERIOD_CURRENT,5),iLow(Symbol(),PERIOD_CURRENT,97),x1,y1);
      priceWidth=x1-x;
      priceHeight=y1-y;
      canvas2222.FillRectangle(0,0,priceWidth,priceHeight,ColorToARGB(clrRed,80));
      canvas2222.Update();
      //ObjectSetInteger(0,"Test_2222",OBJPROP_XSIZE,priceWidth);
      //ObjectSetInteger(0,"Test_2222",OBJPROP_YSIZE,priceHeight);
      Comment(Counter);
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
